#ifndef PlayState_H
#define PlayState_H

#include <OIS/OIS.h>
#include <MyGUI.h>

#include "ClientGameState.h"
#include "IntroState.h"

class PlayState : public ClientGameState
{
public:
    ~PlayState( void );

	void enter( void );
    void exit( void );

    void pause( void );
    void resume( void );
	void gameOver(void);
    void update( unsigned long lTimeElapsedInMilis );

    void keyPressed( const OIS::KeyEvent &e );
    void keyReleased( const OIS::KeyEvent &e );

	bool frameStarted(const Ogre::FrameEvent& evt);

    void mouseMoved( const OIS::MouseEvent &e );
    void mousePressed( const OIS::MouseEvent &e, OIS::MouseButtonID id );
    void mouseReleased( const OIS::MouseEvent &e, OIS::MouseButtonID id );

	void unbufferedInput();

    static PlayState* getSingletonPtr( void );

	bool isActive() { return mIsActive; };


private:
	PlayState( void ) : mIsActive(false) { }
    PlayState( const PlayState& ) : mIsActive(false) { }
    PlayState & operator = ( const PlayState& );
	void resetManagers();
	
    Ogre::Root           *mRoot;
    Ogre::Camera         *mCamera;
    Ogre::SceneManager   *mSceneMgr;
    Ogre::Viewport       *mViewport;
    Ogre::OverlayManager *mOverlayMgr;

	MyGUI::StaticTextPtr scoreText;
	MyGUI::StaticTextPtr speedText;
	MyGUI::StaticTextPtr livesText;
	MyGUI::StaticTextPtr coordsText;

    OIS::Keyboard        *mInputDevice;

	void setupScene();

	bool mIsActive;
    static PlayState *mPlayState;

	MyGUI::VectorWidgetPtr widgetPtr;

	MyGUI::HScrollPtr stiffnessScroll;
	MyGUI::StaticTextPtr stiffnessText;

	MyGUI::HScrollPtr dampeningScroll;
	MyGUI::StaticTextPtr dampeningText;

	MyGUI::HScrollPtr massScroll;
	MyGUI::StaticTextPtr massText;

	MyGUI::StaticTextPtr deadReckoningText;

};
#endif
