#ifndef ServerNetworkNode_H
#define ServerNetworkNode_H

#include <winsock2.h>
#include <list>
#include <Ogre.h>
#include <string>

class ServerNetworkNode
{
public:
	ServerNetworkNode() { initialized = false; };
	virtual ~ServerNetworkNode() {};

	void start(u_short port);

	// called by "start()"
	void initSockets(); 

	// should be called before readPacket()
	bool hasMorePackets();

	// should be called each frame (in a loop with hasMorePackets() )
	int readPacket(sockaddr_in * senderAddress, char * readBuffer, int readBufferMaxSize);

	int sendToClient(const sockaddr_in * clientAddress, const char * data, const int dataSize);
	int sendToClient(const std::string clientName, const char * data, const int dataSize);

	void sendToAll(const char * data, const int dataSize);
	void sendToAllExceptOneClient(const sockaddr_in * clientAddressNotToSend, const char * data, 
									const int dataSize);
	void sendToAllExceptOneClient(const std::string clientNameNotToSend, const char * data, 
									const int dataSize);

	bool handlePacketRequestConnection(sockaddr_in * clientAddress, const char * data, int dataSize);
	bool handlePacketPlayerRequestsExit(sockaddr_in * clientAddress, const char * data, int dataSize);

	void stop();

	bool isInitialized() { return initialized; };

	int getNumberOfConnectedClients() { return mConnectedClientsMap.size(); };
	void removeClient(std::string nameToRemove);

	//std::string getIP() { return std::string( inet_ntoa(mServerSockAddr.sin_addr) ); };

private:
	bool initialized;

	u_short mPortNumber;

	sockaddr_in mServerSockAddr;
	SOCKET mSocket;

	static const unsigned int maxClients = 3;

	//std::list<ConnectedClient> mConnectedClients;
	std::map<std::string, sockaddr_in> mConnectedClientsMap;

};

#endif
