#include "ConnectionSet.h"

ConnectionSet::ConnectionSet(void)
{
	fdmax = 0;
}
// ===========================================================================
ConnectionSet::~ConnectionSet(void)
{
}
// ===========================================================================
ConnectionSet::ConnectionSet( const ConnectionSet & other )
{
	this->fdmax = other.fdmax;
	this->connectionSet = other.connectionSet;
	this->listenerConnectionID = other.listenerConnectionID;
}
// ===========================================================================
ConnectionSet & ConnectionSet::operator=(const ConnectionSet & other)
{
	if (this != &other)
	{  // make sure not same object
        fdmax = other.fdmax;
        connectionSet = other.connectionSet;
        listenerConnectionID = other.listenerConnectionID;
    }

    return *this;    // Return ref for multiple assignment
}
// ===========================================================================
void ConnectionSet::clear()
{
	FD_ZERO(&connectionSet);
}
// ===========================================================================
void ConnectionSet::addConnection( SOCKET connectionID )
{
	//printf("ConnectionSet::addConnection... %d\n", connectionID);
	FD_SET(connectionID, &connectionSet);
	if(connectionID > fdmax)
	{
		fdmax = connectionID;
	}
}
// ===========================================================================
void ConnectionSet::removeConnection( SOCKET connectionID )
{
	FD_CLR(connectionID, &connectionSet);
}
// ===========================================================================
int ConnectionSet::pollConnectionStates()
{
	return select(getMaxNumberOfConnections()+1, &connectionSet, NULL, NULL, NULL);
}
// ===========================================================================
int ConnectionSet::gotRequest( SOCKET connectionID )
{
	return FD_ISSET(connectionID, &connectionSet);
}
// ===========================================================================
