#ifndef ParsingUtils_H
#define ParsingUtils_H

#include <Ogre.h>
#include <Winsock2.h>
#include <ctype.h>
#include <stdarg.h>
#include <string.h>

#include "stdint.h" // <- I had to download this from the Internet ;/

class ParsingUtils
{
public:

	static void parseNetworkedFloatToHost(float & destFloat, const char * buffer);
	static void parseNetworkedQuaternionToHost(Ogre::Quaternion & quaternion, const char * buffer);
	static void parseNetworkedVector3ToHost(Ogre::Vector3 & vector, const char * buffer);

	static void parseHostFloatToNetwork(char * destBuffer, const float & sourceFloat);
	static void parseHostQuaternionToNetwork(char * destBuffer, const Ogre::Quaternion & quaternion);
	static void parseHostVector3ToNetwork(char * destBuffer, const Ogre::Vector3 & vector);

	// These are  taken from Beej's Guide To Network Programming 
	// http://beej.us/guide/bgnet/output/html/singlepage/bgnet.html#htonsman
	static uint32_t		htonf(float f);
	static float			ntohf(uint32_t p);
	static long long		pack754(long double f, unsigned bits, unsigned expbits);
	static long double		unpack754(long long i, unsigned bits, unsigned expbits);
	static void			packi16(unsigned char *buf, unsigned int i);
	static void			packi32(unsigned char *buf, unsigned long i);
	static unsigned int	unpacki16(unsigned char *buf);
	static unsigned long	unpacki32(unsigned char *buf);
	static size_t			pack(unsigned char *buf, char *format, ...);
	static void			unpack(unsigned char *buf, char *format, ...);

};

#endif